clear all, close all, clc

[fname,fpath]=uigetfile('../dat/*.*'); % input file, select normal dat
T=dlmread([fpath fname],'',1,0);
[pathstr,name,ext] = fileparts(fname);


%---------------possible changes


l=3; %<------------------------------- electrode space in meter
nbin = 40;%<-------------------------- How many bins the histogram has

%---------------
%--------------- Remove negative resistances:
%  indices = find(T(:,5)<=0); 
%      T(indices,:) = [];
    
A = T(:,1); % current electrode
B = T(:,2); % current electrode
M = T(:,3); % potential electrode
N = T(:,4); % potential electrode
R = T(:,5); % Resistance


%------------------- calculate pseudosection x, z coordinates
x_raw=[];
z_raw=[];
zmna=[];
zmnb=[];
for n=1:length(A)
    if ((A(n)<M(n) & A(n)<N(n)) & (B(n)<M(n) & B(n)<N(n)))
        x_raw = [x_raw; ((A(n)+B(n))*l/2+(N(n)+M(n))*l/2)/2]; 
        z_raw = [z_raw; -((((A(n)+B(n))*l/2+(N(n)+M(n))*l/2)/2)-(A(n)+B(n))*l/2)];
    else
        ;   
    end
end

%------------------- calculate geometrical coeff and apparent resistivity

k=2*pi*(1./((1./abs(A-M))-(1./abs(A-N))-(1./abs(B-M))+(1./abs(B-N))));
ro=k.*R;  
l_ro=log10(ro);


V=[x_raw z_raw l_ro];
V2=sortrows(V,[1 -2]);
X=50;
dotsize=[X; X; X; X; X];
for n=6:length(V2)
    if V2(n,1)==V2(n-1,1) & V2(n,2)==V2(n-1,2)
        dotsize=[dotsize; X/3];
    elseif V2(n,1)==V2(n-3,1) & V2(n,2)==V2(n-3,2)
        dotsize=[dotsize; X/4];
    elseif V2(n,1)==V2(n-4,1) & V2(n,2)==V2(n-4,2)
        dotsize=[dotsize; X/5];
    elseif V2(n,1)==V2(n-5,1) & V2(n,2)==V2(n-5,2)
        dotsize=[dotsize; X/6];
    else
        dotsize=[dotsize; X];
        
  end
end
xraw=V2(:,1);
zraw=V2(:,2);
lro=V2(:,3);

%------------------Plot----------------------------------

%--------Apparent resistivity
h1=figure
scatter(xraw,zraw,dotsize,lro,'filled');
hcb = colorbar('horizontal');
xlabel('x [m]', 'FontSize', 12)
ylabel('pseudodepth [m]', 'FontSize', 12)
xlabel(hcb,'log_{10} \rho_{app} [\Omegam]', 'FontSize', 12)

%---- hist of app res in log
h2=figure
hist(l_ro,nbin);
xlabel('log_{10} \rho_{app} [\Omegam]', 'FontSize', 12)


